/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: tabudemo.cpp,v 1.4 1997/06/24 17:33:18 reichel Exp $ *
 ***********************************************************************/


//
// $Id: tabudemo.cpp,v 1.4 1997/06/24 17:33:18 reichel Exp $
//
#include <fstream.h>
#include <curses.h>
#include <time.h>
#include <stdlib.h>
#include <iomanip.h>


#include "plan.h"
#include "tabu.h"

main(void)
{
  time_t tm;
  plan *p = new plan();
  tabu *t;
  break_struct b;
  para_struct pa;

  b.what = B_KEY;
  b.value = 0.9;
  b.tm = 3;
 
  pa.SearchDepth = -1;
  pa.SearchRepeat = -1;
  pa.TriesTillRandom = -1;
  pa.HashSize = -1;
  pa.what = P_OUTPUT | P_DEBUG;

  srand((unsigned) time(&tm));
  p->test_init();
  p->evaluate_plan();
  p->short_out_sched();


  t = new tabu(p,b,pa);

  t->tabu_repair_broad();

  p->short_out_sched();
  delete p;
  delete t;
}

// $Log: tabudemo.cpp,v $
// Revision 1.4  1997/06/24 17:33:18  reichel
//  ----------------------------------------------------------------------
// Address changed
//
//  Committing in optiflip//tabuflip
//
//  Modified Files:
//  	hash.h plan.h tabu.h tabudemo.cpp
//  ----------------------------------------------------------------------
//
// Revision 1.3  1997/06/24 13:26:05  reichel
//  ----------------------------------------------------------------------
// URL changed
//
//  Committing in optiflip//tabuflip
//
//  Modified Files:
//  	hash.h plan.h tabu.h tabudemo.cpp
//  ----------------------------------------------------------------------
//
// Revision 1.2  1997/05/26 13:24:17  reichel
//  ----------------------------------------------------------------------
// LGPL
//
//  Committing in sflip//conflip
//
//  Modified Files:
//  	bool.h cflp_dyn.cpp cflp_dyn.h cflp_flp.h cflperr.h
//  	cflplib.cpp cflplib.h cflplist.cpp cflplist.h common.cpp
//  	common.h conflip.cpp conflip.h demo1.cpp errort.cpp errort.h
//  	errtxt.cpp mytest.cpp
//  ----------------------------------------------------------------------
//  ----------------------------------------------------------------------
// LGPL
//
//  Committing in sflip//domflip
//
//  Modified Files:
//  	bool.h cflplist.cpp cflplist.h common.cpp common.h cviolat.cpp
//  	cviolat.h cviollst.cpp cviollst.h demo1.cpp demo2.cpp
//  	domagg.cpp domagg.h domaglst.cpp domaglst.h domain1.cpp
//  	domain1.h domerr.h domflip.cpp domflip.h domlib.cpp domlib.h
//  	domlib1.cpp domlib2.cpp domlist.cpp domlist.h errort.cpp
//  	errort.h errtxtdm.cpp genalg.cpp genalg.h hash.cpp hash.h
//  	order.cpp order.h repair.cpp repair.h replst.cpp replst.h
//  	repstepd.h tabu.cpp tabu.h
//  ----------------------------------------------------------------------
//  ----------------------------------------------------------------------
// LGPL
//
//  Committing in sflip//dynaflip
//
//  Modified Files:
//  	evaltree.cpp evaltree.h expint.cpp expint.h flip.h
//  	flipcvar.cpp flipcvar.h flipdemo.cpp flipoper.cpp flipoper.h
//  	flippara.cpp flippara.h fliprule.cpp fliprule.h fliptest.cpp
//  	inter.cpp
//  ----------------------------------------------------------------------
//  ----------------------------------------------------------------------
// LGPL
//
//  Committing in sflip//flip
//
//  Modified Files:
//  	flip.h flipcvar.cpp flipcvar.h flipdemo.cpp flipoper.cpp
//  	flipoper.h flippara.cpp flippara.h fliprule.cpp fliprule.h
//  	fliptest.cpp
//  ----------------------------------------------------------------------
//  ----------------------------------------------------------------------
// LGPL
//
//  Committing in sflip//optiflip/tabuflip
//
//  Modified Files:
//  	hash.h plan.h tabu.h tabudemo.cpp
//  ----------------------------------------------------------------------
//
// Revision 1.1  1997/05/02 14:18:54  reichel
// ----------------------------------------------------------------------
// Renamed all .cc and .cxx to .cpp (as in wxWin), and modified references
// to previous filenames
//
//  Committing in sflip/conflip
//
//  Modified Files:
//  	makefile
//  Added Files:
//  	cflp_dyn.cpp cflplib.cpp cflplist.cpp common.cpp conflip.cpp
//  	demo1.cpp errort.cpp errtxt.cpp mytest.cpp
//  Removed Files:
//  	cflp_dyn.cc cflplib.cc cflplist.cc common.cc conflip.cc
//  	demo1.cc errort.cc errtxt.cc mytest.cc
// ----------------------------------------------------------------------
//
//  Committing in sflip/docuflip/ConFLIP
//
//  Modified Files:
//  	conflib.htm
// ----------------------------------------------------------------------
//
//  Committing in sflip/docuflip/DynaFLIP/CSI
//
//  Modified Files:
//  	ka7_5.htm
// ----------------------------------------------------------------------
//
//  Committing in sflip/docuflip/FLIP
//
//  Modified Files:
//  	fliplib.htm
// ----------------------------------------------------------------------
//
//  Committing in sflip/domflip
//
//  Modified Files:
//  	README WARNINGS_2.4.5 makedemo2 makefile makefile3
//  Added Files:
//  	cflplist.cpp common.cpp cviolation.cpp cviollst.cpp demo1.cpp
//  	demo2.cpp domagg.cpp domagglst.cpp domain1.cpp domflip.cpp
//  	domlib.cpp domlib1.cpp domlib2.cpp domlist.cpp errort.cpp
//  	errtxtdom.cpp genalg.cpp hash.cpp order.cpp repair.cpp
//  	replst.cpp tabu.cpp
//  Removed Files:
//  	cflplist.cxx common.cxx cviolation.cxx cviollst.cxx demo1.cxx
//  	demo2.cxx domagg.cxx domagglst.cxx domain1.cxx domflip.cxx
//  	domlib.cxx domlib1.cxx domlib2.cxx domlist.cxx errort.cxx
//  	errtxtdom.cxx genalg.cxx hash.cxx order.cxx repair.cxx
//  	replst.cxx tabu.cxx
// ----------------------------------------------------------------------
//
//  Committing in sflip/dynaflip
//
//  Modified Files:
//  	flip.h makefile
//  Added Files:
//  	evaltree.cpp expint.cpp flipcvar.cpp flipdemo.cpp flipoper.cpp
//  	flippara.cpp fliprule.cpp fliptest.cpp inter.cpp
//  Removed Files:
//  	evaltree.cc expint.cc flipcvar.cc flipdemo.cc flipoper.cc
//  	flippara.cc fliprule.cc fliptest.cc inter.cc
// ----------------------------------------------------------------------
//
//  Committing in sflip/flip
//
//  Modified Files:
//  	flip.h makefile
//  Added Files:
//  	flipcvar.cpp flipdemo.cpp flipoper.cpp flippara.cpp
//  	fliprule.cpp fliptest.cpp
//  Removed Files:
//  	flipcvar.cc flipdemo.cc flipoper.cc flippara.cc fliprule.cc
//  	fliptest.cc
// ----------------------------------------------------------------------
//
//  Committing in sflip/optiflip/tabuflip
//
//  Modified Files:
//  	makefile
//  Added Files:
//  	tabudemo.cpp
//  Removed Files:
//  	tabudemo.cc
// ----------------------------------------------------------------------
//
// Revision 1.1  1996/02/22 16:44:38  raggl
// Reorganized TabuFLIP files (makefile, tabu.doc, ...)
//
// Revision 1.5  1996/02/14 10:30:48  raggl
// Another empty line added
//
// Revision 1.4  1996/02/14 10:29:25  raggl
// empty line added
//
// Revision 1.3  1996/02/14 10:25:41  raggl
// another test of logging
//
// Revision 1.2  1996/02/14 10:19:02  raggl
// Test logging within cc-file



